package com.sdtool.common.tool;


import com.sdtool.common.entity.system.Menu;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by jlutt on 2018-07-14.
 * 树形菜单处理
 *
 * @author jlutt
 */
public class TreeMenuUtils {


    /**
     * 生成树形菜单
     *
     * @param list
     * @param parentId
     * @return
     */
    public static List<Menu> generateTreeMenus(List<Menu> list, long parentId) {
        List<Menu> returnList = new ArrayList<>();
        for (Menu t : list) {
            // 一、根据传入的某个父节点ID,遍历该父节点的所有子节点
            if (t.getParentId() == parentId) {
                recursionFn(list, t);
                returnList.add(t);
            }
        }
        return returnList;
    }

    private static void recursionFn(List<Menu> list, Menu t) {
        // 得到子节点列表
        List<Menu> childList = getChildList(list, t);
        t.setChildren(childList);
        for (Menu tChild : childList) {
            if (hasChild(list, tChild)) {
                // 判断是否有子节点
                for (Menu n : childList) {
                    recursionFn(list, n);
                }
            }
        }
    }

    /**
     * 得到子节点列表
     */
    private static List<Menu> getChildList(List<Menu> list, Menu t) {

        List<Menu> tlist = new ArrayList<>();
        for (Menu n : list) {
            if (n.getParentId() == t.getId()) {
                tlist.add(n);
            }
        }
        return tlist;
    }

    /**
     * 判断是否有子节点
     */
    private static boolean hasChild(List<Menu> list, Menu t) {
        return !getChildList(list, t).isEmpty();
    }
}
